package org.xpnd.impl.modelizer.xpp;

import java.util.Enumeration;
import java.util.Hashtable;

import org.lixm.optional.v11.namespace.NamespaceBinding;

public class NamespaceBindingImpl implements NamespaceBinding {

    private Hashtable uris;
    private Hashtable prefixs;

    public NamespaceBindingImpl() {
	uris = new Hashtable();
	prefixs = new Hashtable();
    }

    public String getNamespaceURI(Object prefix){
	return (String)uris.get(prefix);
    }

    public Object getPrefix(String namespaceURI){
	return prefixs.get(namespaceURI);
    }

    public Object[] getPrefixes(String namespaceURI){

	Enumeration prefixEnum = prefixs.elements();
	Object[] prefixObujects = new Object[prefixs.size()];
	int i=0;
	while (prefixEnum.hasMoreElements()) {
	    prefixObujects[i] = prefixEnum.nextElement();
	    i++;
	}
	return prefixObujects;
    }

    public Object put(Object prefix, String namespaceURI){

	Object prefixObject = prefixs.get(namespaceURI);
	uris.put(prefix, namespaceURI);
	prefixs.put(namespaceURI, prefix);
	return (prefixObject != null) ? prefixObject : null;
    }

    public Object remove(Object key){
	String namespaceURI = (String)uris.get(key);
	uris.remove(key);
	Object prefix = prefixs.remove(namespaceURI);
	return prefix;
    }
}
